/******************************
 * Sysdownlight.c
 *    
 * : 29.12.2018 18:10:02
 * :  .
 *******************************/ 

#include <avr/io.h>
#include <util/delay_basic.h>
#include <avr/sfr_defs.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include "Basedefine.h"
#include "Sysdownlight.h"
#include "Adconvert.h"

bit_sys sys_index={0,0,0,0}; // 
var_sys sys_data={0,0,0,0,0}; // 

ISR(INT0_vect) //         PD2  
	{
	ClearBit(GICR,INT0); //   INT0
	if(sys_index.onofflamp==FALSE) ClearBit(GICR,INT1); //   INT1   
	if(SYS_KeyScanning(TRUE)==TRUE) SYS_OnoffLamp(); //    / 
	while(SYS_KeyScanning(FALSE)==FALSE); //  
	if(sys_index.onofflamp==TRUE) SetBit(GICR,INT0); //   INT0      
	}

ISR(INT1_vect) //         PD3  
	{
	ClearBit(GICR,INT0); //   INT0
	ClearBit(GICR,INT1); //   INT1
	}

void SYS_LightService(void) //  
	{
	sys_data.voltagebattery=Adc_ReadData(BATTERY_MEASURE)*2; //   
	sys_data.voltagesolarpanel=Adc_ReadData(SOLAR_MEASURE)*2; //    
	SYS_CheckCharge(); //   
	if((sys_index.onofflamp==TRUE)&&(bit_is_clear(PIND,PIND1))) //      
		{
		SYS_TimeDelay(10); // 10 
		sys_data.countdatatime++; //  
		sys_data.countledstate++; //     
		if(sys_data.countledstate>49) //  0,5  
			{
			if(sys_index.onoffledstate==FALSE) //    
				{
				sys_index.onoffledstate=TRUE; //   
				ClearBit(PORTD,PD5); //   
				}
			else
				{
				sys_index.onoffledstate=FALSE; //  
				SetBit(PORTD,PD5); //  
				}
			sys_data.countledstate=0; //    
			}
		if((sys_data.countdatatime>=60000)||(sys_index.batterydead==TRUE)) //  10    
			{
			cli(); //  
			ClearBit(GICR,INT0); //   INT0  
			SYS_OnoffLamp(); // 
			}
		}
	else if((sys_index.onofflamp==TRUE)&&(bit_is_set(PIND,PIND1))&&(sys_index.batterydead==TRUE)) //  ,     
		{
		cli(); //  
		ClearBit(GICR,INT0); //   INT0  
		SYS_OnoffLamp(); // 
		}
	else if(sys_index.onofflamp==FALSE) //  
		{
		if(SYS_KeyScanning(FALSE)==TRUE) //    
			{
			if(sys_data.countdatatime>0) sys_data.countdatatime=0; //     
			if(sys_data.decodeledstatus>0) sys_data.decodeledstatus=0; //    
			if(sys_index.onoffledstate==TRUE) //   
				{
				sys_index.onoffledstate=FALSE; //  
				SetBit(PORTD,PD5); //  
				}
			SYS_PreparingSleep(); //     
			SYS_TransitionSleep(); //    
			}
		}
	}

void SYS_TimeDelay(word millseconds_prm) //    
	{
	word millseconds_tmp; // 
	millseconds_tmp=millseconds_prm; //  
	while(millseconds_tmp>0) //   
		{
		_delay_loop_2(2000); //  1    
		millseconds_tmp--; //  
		}
	}

bit SYS_KeyScanning(bit scanningstatus_prm) //  
	{
	bit buttonstate_tmp=FALSE; //   
	switch(scanningstatus_prm) //  
		{
		case FALSE: if(bit_is_set(PIND,PIND2)) //  
						{
						SYS_TimeDelay(20); // 20 
						if(bit_is_set(PIND,PIND2)) buttonstate_tmp=TRUE; //     
						}
					break;
		case TRUE: if(bit_is_clear(PIND,PIND2)) //  
						{
						SYS_TimeDelay(20); // 20 
						if(bit_is_clear(PIND,PIND2)) buttonstate_tmp=TRUE; //     
						}
		}
	return buttonstate_tmp; //  
	}

void SYS_OnoffLamp(void) // / 
	{
	if(sys_index.onofflamp==FALSE) //  
		{
		if(bit_is_set(PIND,PIND1)) ClearBit(PORTD,PD5); //      
		ClearBit(PORTD,PD6); //   PD6  
		sys_index.onofflamp=TRUE; //   
		}
	else //  
		{
		if(bit_is_set(PIND,PIND1)) SetBit(PORTD,PD5); //      
		SetBit(PORTD,PD6); //     
		sys_index.onofflamp=FALSE; //   
		}
	}

void SYS_PreparingSleep(void) //      
	{
	SetBit(DDRD,DDD3); //      
	SetBit(PORTD,PD3); //       
	SYS_LedoutStatus(); //     30 
	ClearBit(DDRD,DDD3); //   
	ClearBit(PORTD,PD3); //  
	}

void SYS_TransitionSleep(void) //     
	{
	SetBit(GICR,INT0); //   INT0  
	SetBit(GICR,INT1); //   INT1  
	sei(); //  
	set_sleep_mode(SLEEP_MODE_PWR_DOWN); //   
	sleep_mode();
	}

void SYS_LedoutStatus(void) //  
	{
	if((sys_index.batterynotcharge==FALSE)&&(sys_index.batterydead==FALSE))
		{
		ClearBit(PORTD,PD4); //  
		SYS_TimeDelay(30); //  30 
		SetBit(PORTD,PD4); //  
		}
	else if((sys_index.batterynotcharge==TRUE)&&(sys_index.batterydead==FALSE))
		{
		ClearBit(PORTD,PD4); //  
		SYS_TimeDelay(15); //  15 
		SetBit(PORTD,PD4); //  
		ClearBit(PORTD,PD5); //  
		SYS_TimeDelay(15); //  15 
		SetBit(PORTD,PD5); //  
		}
	else if(sys_index.batterydead==TRUE)
		{
		ClearBit(PORTD,PD5); //  
		SYS_TimeDelay(30); //  30 
		SetBit(PORTD,PD5); //  
		}
	}

void SYS_CheckCharge(void) //   
	{
	if((sys_data.voltagebattery<=2900)&&(sys_index.batterydead==FALSE)) sys_index.batterydead=TRUE; //      3 
	else if((sys_data.voltagebattery>3000)&&(sys_index.batterydead==TRUE)) sys_index.batterydead=FALSE; //     3   
	if((sys_data.voltagesolarpanel>sys_data.voltagebattery)&&(sys_index.batterynotcharge==TRUE)) //           
		{
		if((sys_data.voltagesolarpanel-sys_data.voltagebattery)>=150) sys_index.batterynotcharge=FALSE; //    150         
		}
	else if((sys_data.voltagesolarpanel>sys_data.voltagebattery)&&(sys_index.batterynotcharge==FALSE)) //           
		{
		if((sys_data.voltagesolarpanel-sys_data.voltagebattery)<150) sys_index.batterynotcharge=TRUE; //   150       
		}
	else if((sys_data.voltagesolarpanel<=sys_data.voltagebattery)&&(sys_index.batterynotcharge==FALSE)) //             
		{
		sys_index.batterynotcharge=TRUE; //    
		}
	if(sys_index.batterynotcharge==TRUE) //     
		{
		if(bit_is_set(PIND,PIND7)) ClearBit(PORTD,PD7); //       
		}
	else //     
		{
		if((sys_data.voltagebattery>=4190)&&(bit_is_set(PIND,PIND7))) ClearBit(PORTD,PD7); //        4,2 
		else if((sys_data.voltagebattery<=4090)&&(bit_is_clear(PIND,PIND7))) SetBit(PORTD,PD7); //        4,1 
		}
	}



